//
//  TextViewPas.m
//  ataula
//
//  Created by Andreu Biosca on 09/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import "TextViewPas.h"
#import "IncludesCompartits.h"
#import "ViewControllerPas.h"

@implementation TextViewPas

-(void)setModePlaceholder
{
    self.text = PLACEHOLDER_DESCRIPCIO;
    self.textColor = UIColorFromRGB(0xCCCCCC);
}

-(void)setModeNormal
{
    self.textColor = UIColor.blackColor;
}

-(bool)esModePlaceholder
{
    
    return self.textColor != UIColor.blackColor;
    
}

- (void)textViewDidBeginEditing:(UITextView *)textView
{
    if ([textView.text isEqualToString:PLACEHOLDER_DESCRIPCIO])textView.text = @"";
    
    [self setModeNormal];
    
    [textView becomeFirstResponder];
}

- (void)textViewDidEndEditing:(UITextView *)textView
{
    if ([textView.text isEqualToString:PLACEHOLDER_DESCRIPCIO])textView.text = @"";
    
    if ([textView.text isEqualToString:@""]) {
        [self setModePlaceholder];
    }else{
        [self setModeNormal];
    }
    
    [textView resignFirstResponder];
    
}

- (void)textViewDidChange:(UITextView *)textView
{
    
    if([self isFirstResponder])
    {
        
        // hem fet edició manual
        
        [self.oViewControllerPas reiniciaPredictiuEnFuncioTextView];
        
    }
    
}

@end
