//
//  IncludesCompartits.h
//  Snapplic
//
//  Created by Andreu Biosca on 02/11/2018.
//  Copyright © 2018 Grupo Globalia. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Define.h"
#import "AFHTTPSessionManager.h"

#define UIColorFromRGB(rgbValue) [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 green:((float)((rgbValue & 0xFF00) >> 8))/255.0 blue:((float)(rgbValue & 0xFF))/255.0 alpha:1.0]
#define MISSATGE_ERROR_DEFECTE_WS @"Hi ha hagut un error amb el servei web. Revisa que disposes de connexió a internet."

@interface IncludesCompartits : NSObject

+(UIBarButtonItem*_Nonnull)navigationBarAfegirBotoDreta:(UIViewController*_Nonnull)viewcontroller imatge:(UIImage*_Nonnull)imatge size:(CGSize)size action:(SEL _Nonnull )action target:(nullable id)target;
+(UIBarButtonItem*_Nonnull)navigationBarAfegirBotoEsquerra:(UIViewController*_Nonnull)viewcontroller imatge:(UIImage*_Nonnull)imatge size:(CGSize)size action:(SEL _Nonnull )action target:(nullable id)target;
+(NSMutableArray*_Nonnull)navigationBarAfegirBotonsDreta:(UIViewController*_Nonnull)viewcontroller aBotons:(NSArray*_Nonnull)aBotons;
+(void)tabbarSetImages:(UITabBar*_Nonnull)tabBar imatges:(NSArray*_Nonnull)imatges imatgesFilled:(NSArray*_Nonnull)imatgesFilled colorSeleccio:(UIColor*_Nonnull)colorSeleccio colorDeseleccionat:(UIColor*_Nonnull)colorDeseleccionat;
+(void)tabbarSetTextos:(UITabBar*_Nonnull)tabBar colorSeleccio:(UIColor*_Nonnull)colorSeleccio colorDeseleccionat:(UIColor*_Nonnull)colorDeseleccionat;

+(UIView*_Nonnull)creaVistaPreloader:(UIViewController*_Nonnull)frameReferencia;
+(NSString*_Nonnull)carregaPreferencia:(NSString*_Nonnull)sPreferencia;
+(void)gravaPreferencia:(NSString*_Nonnull)sPreferencia valor:(NSString*_Nonnull)valor;
+(void)eliminaPreferencia:(NSString*_Nonnull)sPreferencia;
+(UIAlertController*_Nonnull)creaAlerta:(NSString*_Nonnull)titol descripcio:(NSString*_Nonnull)descripcio;
+(NSMutableArray*_Nonnull)carregaPreferenciaArray:(NSString*_Nonnull)sPreferencia;
+(void)gravaPreferenciaArray:(NSString*_Nonnull)sPreferencia valor:(NSMutableArray*_Nonnull)valor;
+(UIImage*_Nonnull)getResizedImage:(UIImage*_Nonnull)original_image iMaxWidth:(int)iMaxWidth iMaxHeight:(int)iMaxHeight;

// Funcions de sintagmes i predicció

+(NSString*_Nonnull)retornaParaulaAmbAAl:(NSString*_Nonnull)genere numero:(NSString*_Nonnull)numero paraula:(NSString*_Nonnull)paraula;
+(NSString*_Nonnull)retornaParaulaAmbArticle:(NSString*_Nonnull)genere numero:(NSString*_Nonnull)numero paraula:(NSString*_Nonnull)paraula;
+(NSString*_Nonnull)converteixAMinusculaLaPrimeraLletra:(NSString*_Nonnull)paraula;
+(NSString*_Nonnull)retornaParaulaAmbPreposicio:(NSString*_Nonnull)paraula;
+(NSString*_Nonnull)retornaIngredientARecepta:(NSString*_Nonnull)genere nom_singular:(NSString*_Nonnull)nom_singular nom_plural:(NSString*_Nonnull)nom_plural quantitat:(NSString*_Nonnull)quantitat unitat:(NSString*_Nonnull)unitat utilitza_unitat:(NSString*_Nonnull)utilitza_unitat;
+(NSString*_Nonnull)retornaIngredientAReceptaAmbArticle:(NSString*_Nonnull)utilitza_unitat nom_singular:(NSString*_Nonnull)nom_singular nom_plural:(NSString*_Nonnull)nom_plural quantitat:(NSString*_Nonnull)quantitat genere:(NSString*_Nonnull)genere;
+(NSString*_Nonnull)formataADoble:(NSString*_Nonnull)sEntrada;
+(bool)ingredientEsPlural:(NSString*_Nonnull)utilitza_unitat nom_singular:(NSString*_Nonnull)nom_singular nom_plural:(NSString*_Nonnull)nom_plural quantitat:(NSString*_Nonnull)quantitat;

@end
