//
//  ViewControllerIngredient.h
//  ataula
//
//  Created by Andreu Biosca on 04/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuickLook/QuickLook.h>

@class ViewControllerIngredients;
@class ViewControllerAfegirIngredientRecepta;

NS_ASSUME_NONNULL_BEGIN

#define ALPHA_BOTO_DESELECCIONAT .1

@interface ViewControllerIngredient : UIViewController <UIImagePickerControllerDelegate, UIScrollViewDelegate, QLPreviewControllerDelegate, QLPreviewControllerDataSource, UINavigationControllerDelegate>

@property NSString *idIngredient;
@property (strong, nonatomic) IBOutlet UIView *vistaFoto;
@property UIImageView *imgvFoto;
@property (strong, nonatomic) IBOutlet UIImageView *camera;
@property (strong, nonatomic) IBOutlet UIButton *boto_genere_M;
@property (strong, nonatomic) IBOutlet UIButton *boto_genere_F;
@property (strong, nonatomic) IBOutlet UIButton *boto_unitat_g;
@property (strong, nonatomic) IBOutlet UIButton *boto_unitat_ml;
@property (strong, nonatomic) IBOutlet UITextField *textfield_nom_singular;
@property (strong, nonatomic) IBOutlet UITextField *textfield_nom_plural;
@property (strong, nonatomic) IBOutlet UIButton *boto_accio;
@property (strong, nonatomic) IBOutlet UIScrollView *scrollview;
@property NSData *dataNovaImatge;
@property (strong, nonatomic) IBOutlet UIView *vista_capsalera;
@property UIView *vista_preloader;
@property ViewControllerIngredients *oViewControllerIngredients;
@property ViewControllerAfegirIngredientRecepta *oViewControllerAfegirIngredientRecepta;
@property bool bForçarAmbduesFormes;
@property NSMutableArray *aTempDocumentURL;

@end

NS_ASSUME_NONNULL_END
