<?php

function login($con) {

    sleep(.3);

    $pw = isset($_POST["pw"]) && !empty($_POST["pw"]) ? $_POST["pw"] : "";

    $bLoginCorrecte = $pw == "perepoma";

    if($bLoginCorrecte){

        if (session_status() == PHP_SESSION_NONE)session_start();
        $_SESSION["CONECTATS"] = "SI";

    }

    $aReturn = array();
    $aReturn['result'] = $bLoginCorrecte ? "0" : "1";
    print json_encode($aReturn);

}

function logout($con) {

    if (session_status() == PHP_SESSION_NONE)session_start();

    unset($_SESSION["CONECTATS"]);

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}


function cercaIngredients($con) {

    $cerca = isset($_POST["cerca"]) && !empty($_POST["cerca"]) ? $_POST["cerca"] : "";

    $sConsultaCerca = $cerca == "" ? "" : "WHERE nom_singular LIKE '%$cerca%' OR nom_plural LIKE '%$cerca%'" ;

    $aEntities = array();

    $result = mysqli_query($con, "SELECT * FROM `" . DB_NAME . "`.`Ingredients` $sConsultaCerca ORDER BY nom_singular ASC, nom_plural ASC");
    while ($row = mysqli_fetch_array($result)) {

        $oEntity = array();

        $oEntity["id"] = $row["id"];
        $oEntity["nom_singular"] = $row["nom_singular"];
        $oEntity["nom_plural"] = $row["nom_plural"];
        $oEntity["genere"] = $row["genere"];
        $oEntity["unitat"] = $row["unitat"];

        // Foto
        $oEntity["foto"] = "";
        if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/" . $oEntity["id"] . "_thumb.png"))$oEntity["foto"] = "/Imatges_elements/Ingredients/".$oEntity["id"]."_thumb.png";
        if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/" . $oEntity["id"] . "_thumb.jpg"))$oEntity["foto"] = "/Imatges_elements/Ingredients/".$oEntity["id"]."_thumb.jpg";

        array_push($aEntities, $oEntity);

    }

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $aEntities;
    print json_encode($aReturn);

}

function cercaReceptes($con) {

    $cerca = isset($_POST["cerca"]) && !empty($_POST["cerca"]) ? $_POST["cerca"] : "";

    $sConsultaCerca = $cerca == "" ? "" : "WHERE titol LIKE '%$cerca%'" ;

    $aEntities = array();

    $result = mysqli_query($con, "SELECT * FROM `" . DB_NAME . "`.`Receptes` $sConsultaCerca ORDER BY titol ASC");
    while ($row = mysqli_fetch_array($result)) {

        $oEntity = array();

        $oEntity["id"] = $row["id"];
        $oEntity["titol"] = $row["titol"];
        $oEntity["preu"] = $row["preu"];
        $oEntity["temps"] = $row["temps"];
        $oEntity["data_creacio"] = $row["data_creacio"];

        // Foto
        $oEntity["foto"] = "";
        if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/" . $oEntity["id"] . "_thumb.png"))$oEntity["foto"] = "/Imatges_elements/Receptes/".$oEntity["id"]."_thumb.png";
        if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/" . $oEntity["id"] . "_thumb.jpg"))$oEntity["foto"] = "/Imatges_elements/Receptes/".$oEntity["id"]."_thumb.jpg";

        array_push($aEntities, $oEntity);

    }

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $aEntities;
    print json_encode($aReturn);

}

function getPassosRecepta($con) {

    $id_recepta = isset($_POST["id_recepta"]) && !empty($_POST["id_recepta"]) ? $_POST["id_recepta"] : "";

    $aEntities = array();

    $result = mysqli_query($con, "SELECT * FROM `" . DB_NAME . "`.`Passos` WHERE id_recepta = $id_recepta ORDER BY numero ASC");
    while ($row = mysqli_fetch_array($result)) {

        $oEntity = array();

        $oEntity["id"] = $row["id"];
        $oEntity["numero"] = $row["numero"];
        $oEntity["descripcio"] = $row["descripcio"];
        $oEntity["num_fotos_adjuntes"] = "0";
        $oEntity["urls_fotos_adjuntes"] = array();

        for ($i=1;$i<=3;$i++)
        {
            $nom_foto = $row["id"]."_".$i."_thumb";
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".png"))
            {
                $oEntity["num_fotos_adjuntes"]++;
                array_push($oEntity["urls_fotos_adjuntes"], "/Imatges_elements/Passos/" . $nom_foto . ".png");
            }
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".jpg"))
            {
                $oEntity["num_fotos_adjuntes"]++;
                array_push($oEntity["urls_fotos_adjuntes"], "/Imatges_elements/Passos/" . $nom_foto . ".jpg");
            }
        }

        array_push($aEntities, $oEntity);

    }

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $aEntities;
    print json_encode($aReturn);

}

function cercaEstris($con) {

    $cerca = isset($_POST["cerca"]) && !empty($_POST["cerca"]) ? $_POST["cerca"] : "";

    $sConsultaCerca = $cerca == "" ? "" : "WHERE nom LIKE '%$cerca%'" ;

    $aEntities = array();

    $result = mysqli_query($con, "SELECT * FROM `" . DB_NAME . "`.`Estris` $sConsultaCerca ORDER BY nom ASC");
    while ($row = mysqli_fetch_array($result)) {

        $oEntity = array();

        $oEntity["id"] = $row["id"];
        $oEntity["nom"] = $row["nom"];
        $oEntity["genere"] = $row["genere"];

        array_push($aEntities, $oEntity);

    }

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $aEntities;
    print json_encode($aReturn);

}

function getIngredientsRecepta($con) {

    $id_recepta = isset($_POST["id_recepta"]) && !empty($_POST["id_recepta"]) ? $_POST["id_recepta"] : "";

    $aEntities = array();

    $result = mysqli_query($con, "SELECT
                                         IngredientARecepta.id, 
                                         IngredientARecepta.quantitat, 
                                         IngredientARecepta.utilitza_unitat,
                                         Ingredients.nom_singular,
                                         Ingredients.nom_plural,
                                         Ingredients.genere,
                                         Ingredients.unitat 
                                  FROM 
                                         `" . DB_NAME . "`.`IngredientARecepta` IngredientARecepta,
                                         `" . DB_NAME . "`.`Ingredients` Ingredients
                                  WHERE 
                                         IngredientARecepta.id_recepta = $id_recepta AND
                                         Ingredients.id = IngredientARecepta.id_ingredient
                                  ORDER BY Ingredients.nom_singular ASC, Ingredients.nom_plural ASC");
    while ($row = mysqli_fetch_array($result)) {

        $oEntity = array();

        $oEntity["id"] = $row["id"];
        $oEntity["quantitat"] = $row["quantitat"];
        $oEntity["utilitza_unitat"] = $row["utilitza_unitat"];
        $oEntity["nom_singular"] = $row["nom_singular"];
        $oEntity["nom_plural"] = $row["nom_plural"];
        $oEntity["genere"] = $row["genere"];
        $oEntity["unitat"] = $row["unitat"];

        array_push($aEntities, $oEntity);

    }

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $aEntities;
    print json_encode($aReturn);

}

function getIngredient($con) {

    $id = isset($_POST["id"]) && !empty($_POST["id"]) ? $_POST["id"] : "";

    $stmt = $con->prepare("SELECT * FROM `" . DB_NAME . "`.`Ingredients` WHERE id = ?");
    $stmt->bind_param("s", $id);
    $stmt->execute();

    $result = $stmt->get_result();

    $aFetchedAssociation = $result->fetch_assoc();

    if($aFetchedAssociation)
    {

        while ($row = $aFetchedAssociation) {

            $oEntity = array();

            $oEntity["id"] = $row["id"];
            $oEntity["nom_singular"] = $row["nom_singular"];
            $oEntity["nom_plural"] = $row["nom_plural"];
            $oEntity["genere"] = $row["genere"];
            $oEntity["unitat"] = $row["unitat"];

            // Foto
            $oEntity["foto"] = "";
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/" . $oEntity["id"] . ".png"))$oEntity["foto"] = "/Imatges_elements/Ingredients/".$oEntity["id"].".png";
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/" . $oEntity["id"] . ".jpg"))$oEntity["foto"] = "/Imatges_elements/Ingredients/".$oEntity["id"].".jpg";

            $aReturn = array();
            $aReturn['result'] = "0";
            $aReturn['data'] = $oEntity;
            print json_encode($aReturn);

            $stmt->close();

            return;

        }

    }else{

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Ingredient no trobat";
        print json_encode($aReturn);

    }

}

function getPas($con) {

    $id = isset($_POST["id"]) && !empty($_POST["id"]) ? $_POST["id"] : "";

    $stmt = $con->prepare("SELECT * FROM `" . DB_NAME . "`.`Passos` WHERE id = ?");
    $stmt->bind_param("s", $id);
    $stmt->execute();

    $result = $stmt->get_result();

    $aFetchedAssociation = $result->fetch_assoc();

    if($aFetchedAssociation)
    {

        while ($row = $aFetchedAssociation) {

            $oEntity = array();

            $oEntity["id"] = $row["id"];
            $oEntity["numero"] = $row["numero"];
            $oEntity["descripcio"] = $row["descripcio"];

            // Fotos

            for ($i=1;$i<=3;$i++)
            {
                $nom_foto = $id."_".$i;
                $oEntity["foto$i"] = "";
                if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".png"))$oEntity["foto$i"] = "/Imatges_elements/Passos/".$nom_foto.".png";
                if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".jpg"))$oEntity["foto$i"] = "/Imatges_elements/Passos/".$nom_foto.".jpg";
            }

            $aReturn = array();
            $aReturn['result'] = "0";
            $aReturn['data'] = $oEntity;
            print json_encode($aReturn);

            $stmt->close();

            return;

        }

    }else{

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Pas no trobat";
        print json_encode($aReturn);

    }

}

function getRecepta($con) {

    $id = isset($_POST["id"]) && !empty($_POST["id"]) ? $_POST["id"] : "";

    $stmt = $con->prepare("SELECT * FROM `" . DB_NAME . "`.`Receptes` WHERE id = ?");
    $stmt->bind_param("s", $id);
    $stmt->execute();

    $result = $stmt->get_result();

    $aFetchedAssociation = $result->fetch_assoc();

    if($aFetchedAssociation)
    {

        while ($row = $aFetchedAssociation) {

            $oEntity = array();

            $oEntity["id"] = $row["id"];
            $oEntity["titol"] = $row["titol"];
            $oEntity["preu"] = $row["preu"];
            $oEntity["temps"] = $row["temps"];
            $oEntity["data_creacio"] = $row["data_creacio"];

            // Foto
            $oEntity["foto"] = "";
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/" . $oEntity["id"] . ".png"))$oEntity["foto"] = "/Imatges_elements/Receptes/".$oEntity["id"].".png";
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/" . $oEntity["id"] . ".jpg"))$oEntity["foto"] = "/Imatges_elements/Receptes/".$oEntity["id"].".jpg";

            $aReturn = array();
            $aReturn['result'] = "0";
            $aReturn['data'] = $oEntity;
            print json_encode($aReturn);

            $stmt->close();

            return;

        }

    }else{

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Recepta no trobada";
        print json_encode($aReturn);

    }

}


function getEstri($con) {

    $id = isset($_POST["id"]) && !empty($_POST["id"]) ? $_POST["id"] : "";

    $stmt = $con->prepare("SELECT * FROM `" . DB_NAME . "`.`Estris` WHERE id = ?");
    $stmt->bind_param("s", $id);
    $stmt->execute();

    $result = $stmt->get_result();

    $aFetchedAssociation = $result->fetch_assoc();

    if($aFetchedAssociation)
    {

        while ($row = $aFetchedAssociation) {

            $oEntity = array();

            $oEntity["id"] = $row["id"];
            $oEntity["nom"] = $row["nom"];
            $oEntity["genere"] = $row["genere"];

            $aReturn = array();
            $aReturn['result'] = "0";
            $aReturn['data'] = $oEntity;
            print json_encode($aReturn);

            $stmt->close();

            return;

        }

    }else{

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Estri no trobat";
        print json_encode($aReturn);

    }

}

function afegirIngredientARecepta($con) {

    $id_ingredient = isset($_POST["id_ingredient"]) && !empty($_POST["id_ingredient"]) ? $_POST["id_ingredient"] : "";
    $id_recepta = isset($_POST["id_recepta"]) && !empty($_POST["id_recepta"]) ? $_POST["id_recepta"] : "";
    $quantitat = isset($_POST["quantitat"]) && !empty($_POST["quantitat"]) ? $_POST["quantitat"] : "";
    $utilitza_unitat = isset($_POST["utilitza_unitat"]) && !empty($_POST["utilitza_unitat"]) ? $_POST["utilitza_unitat"] : "0";

    $stmt = $con->prepare("INSERT INTO `" . DB_NAME . "`.`IngredientARecepta` (id_ingredient, id_recepta, quantitat, utilitza_unitat) VALUES (?, ?, ?, ?)");
    $stmt->bind_param("ssss", $id_ingredient, $id_recepta, $quantitat, $utilitza_unitat);
    $stmt->execute();
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function afegirIngredient($con) {

    $nom_singular = isset($_POST["nom_singular"]) && !empty($_POST["nom_singular"]) ? $_POST["nom_singular"] : "";
    $nom_plural = isset($_POST["nom_plural"]) && !empty($_POST["nom_plural"]) ? $_POST["nom_plural"] : "";
    $genere = isset($_POST["genere"]) && !empty($_POST["genere"]) ? $_POST["genere"] : "";
    $unitat = isset($_POST["unitat"]) && !empty($_POST["unitat"]) ? $_POST["unitat"] : "";

    if( (($nom_singular == "") &&
            ($nom_plural == "")) ||
        ($genere == "") ||
        ($unitat == ""))
    {

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Els camps nom singular, nom plural, gènere i unitat són obligatoris.";
        print json_encode($aReturn);
        return;

    }

    $stmt = $con->prepare("INSERT INTO `" . DB_NAME . "`.`Ingredients` (nom_singular, nom_plural, genere, unitat) VALUES (?, ?, ?, ?)");
    $stmt->bind_param("ssss", $nom_singular, $nom_plural, $genere, $unitat);
    $stmt->execute();
    $id_ingredient_afegit = $stmt->insert_id;
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $id_ingredient_afegit;
    print json_encode($aReturn);

}

function afegirRecepta($con) {

    $ara = date("Y-m-d H:i:s");

    $stmt = $con->prepare("INSERT INTO `" . DB_NAME . "`.`Receptes` (data_creacio) VALUES (?)");
    $stmt->bind_param("s", $ara);
    $stmt->execute();
    $id_recepta_afegida = $stmt->insert_id;
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $id_recepta_afegida;
    print json_encode($aReturn);

}

function afegirEstri($con) {

    $nom = isset($_POST["nom"]) && !empty($_POST["nom"]) ? $_POST["nom"] : "";
    $genere = isset($_POST["genere"]) && !empty($_POST["genere"]) ? $_POST["genere"] : "";

    if( ($genere == "") ||
        ($nom == ""))
    {

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Els camps nom i gènere són obligatoris.";
        print json_encode($aReturn);
        return;

    }

    $stmt = $con->prepare("INSERT INTO `" . DB_NAME . "`.`Estris` (nom, genere) VALUES (?, ?)");
    $stmt->bind_param("ss", $nom, $genere);
    $stmt->execute();
    $id_estri_afegit = $stmt->insert_id;
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $id_estri_afegit;
    print json_encode($aReturn);

}

function afegirPas($con) {

    $descripcio = isset($_POST["descripcio"]) && !empty($_POST["descripcio"]) ? $_POST["descripcio"] : "";
    $id_recepta = isset($_POST["id_recepta"]) && !empty($_POST["id_recepta"]) ? $_POST["id_recepta"] : "";

    $result = mysqli_query($con, "SELECT numero FROM `" . DB_NAME . "`.`Passos` WHERE id_recepta = $id_recepta ORDER BY numero DESC LIMIT 1");
    $fetch = mysqli_fetch_row($result);
    $numero = intval($fetch[0]) + 1;

    $stmt = $con->prepare("INSERT INTO `" . DB_NAME . "`.`Passos` (id_recepta, numero, descripcio) VALUES (?, ?, ?)");
    $stmt->bind_param("sss", $id_recepta, $numero, $descripcio);
    $stmt->execute();
    $id_pas_afegit = $stmt->insert_id;
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $id_pas_afegit;
    print json_encode($aReturn);

}

function editarIngredient($con) {

    $nom_singular = isset($_POST["nom_singular"]) && !empty($_POST["nom_singular"]) ? $_POST["nom_singular"] : "";
    $nom_plural = isset($_POST["nom_plural"]) && !empty($_POST["nom_plural"]) ? $_POST["nom_plural"] : "";
    $genere = isset($_POST["genere"]) && !empty($_POST["genere"]) ? $_POST["genere"] : "";
    $unitat = isset($_POST["unitat"]) && !empty($_POST["unitat"]) ? $_POST["unitat"] : "";
    $id_ingredient = isset($_POST["id_ingredient"]) && !empty($_POST["id_ingredient"]) ? $_POST["id_ingredient"] : "";

    if( (($nom_singular == "") &&
            ($nom_plural == "")) ||
        ($genere == "") ||
        ($unitat == ""))
    {

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Els camps nom singular, nom plural, gènere i unitat són obligatoris.";
        print json_encode($aReturn);
        return;

    }

    $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Ingredients` SET nom_singular = ?, nom_plural = ?, genere = ?, unitat = ? WHERE id = ?");
    $stmt->bind_param("sssss", $nom_singular, $nom_plural, $genere, $unitat, $id_ingredient);
    $stmt->execute();
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function actualitzaTitolRecepta($con) {

    $titol = isset($_POST["titol"]) && !empty($_POST["titol"]) ? $_POST["titol"] : "";
    $id = isset($_POST["id"]) && !empty($_POST["id"]) ? $_POST["id"] : "";

    $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Receptes` SET titol = ? WHERE id = ?");
    $stmt->bind_param("ss", $titol, $id);
    $stmt->execute();
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function actualitzaTempsRecepta($con) {

    $valor = isset($_POST["valor"]) && !empty($_POST["valor"]) ? $_POST["valor"] : "";
    $id = isset($_POST["id"]) && !empty($_POST["id"]) ? $_POST["id"] : "";

    if($valor == "")
    {

        $result = mysqli_query($con, "UPDATE `" . DB_NAME . "`.`Receptes` SET `temps`= NULL WHERE `id` = $id;");

    }else{

        $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Receptes` SET temps = ? WHERE id = ?");
        $stmt->bind_param("ss", $valor, $id);
        $stmt->execute();
        $stmt->close();

    }

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function actualitzaPreuRecepta($con) {

    $valor = isset($_POST["valor"]) && !empty($_POST["valor"]) ? $_POST["valor"] : "";
    $id = isset($_POST["id"]) && !empty($_POST["id"]) ? $_POST["id"] : "";

    if($valor == "")
    {

        $result = mysqli_query($con, "UPDATE `" . DB_NAME . "`.`Receptes` SET `preu`= NULL WHERE `id` = $id;");

    }else{

        $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Receptes` SET preu = ? WHERE id = ?");
        $stmt->bind_param("ss", $valor, $id);
        $stmt->execute();
        $stmt->close();

    }

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function editarEstri($con) {

    $nom = isset($_POST["nom"]) && !empty($_POST["nom"]) ? $_POST["nom"] : "";
    $genere = isset($_POST["genere"]) && !empty($_POST["genere"]) ? $_POST["genere"] : "";
    $id_estri = isset($_POST["id_estri"]) && !empty($_POST["id_estri"]) ? $_POST["id_estri"] : "";

    if( ($genere == "") ||
        ($nom == ""))
    {

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Els camps nom i gènere són obligatoris.";
        print json_encode($aReturn);
        return;

    }

    $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Estris` SET nom = ?, genere = ? WHERE id = ?");
    $stmt->bind_param("sss", $nom, $genere, $id_estri);
    $stmt->execute();
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function editarPas($con) {

    $descripcio = isset($_POST["descripcio"]) && !empty($_POST["descripcio"]) ? $_POST["descripcio"] : "";
    $id_pas = isset($_POST["id_pas"]) && !empty($_POST["id_pas"]) ? $_POST["id_pas"] : "";
    $indexos_fotos_eliminar = isset($_POST["indexos_fotos_eliminar"]) && !empty($_POST["indexos_fotos_eliminar"]) ? $_POST["indexos_fotos_eliminar"] : "";

    $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Passos` SET descripcio = ? WHERE id = ?");
    $stmt->bind_param("ss", $descripcio, $id_pas);
    $stmt->execute();
    $stmt->close();

    $i = 1;
    foreach (explode(",",$indexos_fotos_eliminar) as $valor) {
        if($valor == "1")
        {
            $nom_foto = $id_pas."_".$i;
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".png");
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".jpg");
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.png");
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.jpg");
        }
        $i++;
    }

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function eliminaIngredientSiNoEstaACapRecepta($con) {

    $id_ingredient = isset($_POST["id_ingredient"]) && !empty($_POST["id_ingredient"]) ? $_POST["id_ingredient"] : "";

    $stmt = $con->prepare("SELECT * FROM `" . DB_NAME . "`.`IngredientARecepta` WHERE id_ingredient = ?");
    $stmt->bind_param("s", $id_ingredient);
    $stmt->execute();

    $result = $stmt->get_result();

    $aFetchedAssociation = $result->fetch_assoc();

    if($aFetchedAssociation)
    {

        $stmt = $con->prepare("SELECT titol FROM `" . DB_NAME . "`.`Receptes` WHERE id = ?");
        $stmt->bind_param("s", $aFetchedAssociation["id_recepta"]);
        $stmt->execute();

        $result = $stmt->get_result();

        $aFetchedAssociation = $result->fetch_assoc();

        $aReturn = array();
        $aReturn['result'] = "2";
        $aReturn['avis'] = $aFetchedAssociation["titol"] == "" ? "Aquest ingredient forma part d'alguna recepta, segur que el vols borrar?" :
            "Aquest ingredient forma part d'alguna recepta (per exemple: \"".$aFetchedAssociation["titol"]."\"), segur que el vols borrar?";
        print json_encode($aReturn);

    }else{

        eliminaIngredient($con);

    }

}

function eliminaRecepta($con) {

    $id_recepta = isset($_POST["id_recepta"]) && !empty($_POST["id_recepta"]) ? $_POST["id_recepta"] : "";

    $stmt = $con->prepare("DELETE FROM Receptes WHERE id = ?");
    $stmt->bind_param("i", $id_recepta);
    $stmt->execute();
    $stmt->close();

    $stmt = $con->prepare("DELETE FROM IngredientARecepta WHERE id_recepta = ?");
    $stmt->bind_param("i", $id_recepta);
    $stmt->execute();
    $stmt->close();

    $result = mysqli_query($con, "SELECT * FROM `" . DB_NAME . "`.`Passos` WHERE id_recepta = $id_recepta");
    while ($row = mysqli_fetch_array($result)) {

        for ($i=1;$i<=3;$i++)
        {
            $nom_foto = $row["id"]."_".$i;
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".png");
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".jpg");
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.png");
            if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.jpg");
        }

    }

    $stmt = $con->prepare("DELETE FROM Passos WHERE id_recepta = ?");
    $stmt->bind_param("i", $id_recepta);
    $stmt->execute();
    $stmt->close();

    if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/$id_recepta.jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/$id_recepta.jpg");
    if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/$id_recepta.png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/$id_recepta.png");
    if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/$id_recepta"."_thumb.jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/$id_recepta"."_thumb.jpg");
    if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/$id_recepta"."_thumb.png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Receptes/$id_recepta"."_thumb.png");

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function eliminaIngredient($con) {

    $id_ingredient = isset($_POST["id_ingredient"]) && !empty($_POST["id_ingredient"]) ? $_POST["id_ingredient"] : "";

    $stmt = $con->prepare("DELETE FROM Ingredients WHERE id = ?");
    $stmt->bind_param("i", $id_ingredient);
    $stmt->execute();
    $stmt->close();

    $stmt = $con->prepare("DELETE FROM IngredientARecepta WHERE id_ingredient = ?");
    $stmt->bind_param("i", $id_ingredient);
    $stmt->execute();
    $stmt->close();

    if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/$id_ingredient.jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/$id_ingredient.jpg");
    if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/$id_ingredient.png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/$id_ingredient.png");
    if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/$id_ingredient"."_thumb.jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/$id_ingredient"."_thumb.jpg");
    if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/$id_ingredient"."_thumb.png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Ingredients/$id_ingredient"."_thumb.png");

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function mourePas($con) {

    $id_pas = isset($_POST["id_pas"]) && !empty($_POST["id_pas"]) ? $_POST["id_pas"] : "";
    $nova_posicio = isset($_POST["nova_posicio"]) && !empty($_POST["nova_posicio"]) ? $_POST["nova_posicio"] : "";
    $id_recepta = isset($_POST["id_recepta"]) && !empty($_POST["id_recepta"]) ? $_POST["id_recepta"] : "";

    $result = mysqli_query($con, "SELECT numero FROM `" . DB_NAME . "`.`Passos` WHERE id = $id_pas");
    $fetch = mysqli_fetch_row($result);
    $posicio_actual = $fetch[0];

    if(intval($nova_posicio) < intval($posicio_actual)){

        // Anem cap enrere

        $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Passos` SET numero = numero+1 WHERE id_recepta = ? AND numero >= ? AND numero < ?");
        $stmt->bind_param("iii", $id_recepta, $nova_posicio, $posicio_actual);
        $stmt->execute();
        $stmt->close();

    }else{

        // Anem cap endavant

        $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Passos` SET numero = numero-1 WHERE id_recepta = ? AND numero >= ? AND numero <= ?");
        $stmt->bind_param("iii", $id_recepta, $posicio_actual, $nova_posicio);
        $stmt->execute();
        $stmt->close();

    }

    $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Passos` SET numero = ? WHERE id = ?");
    $stmt->bind_param("ii", $nova_posicio, $id_pas);
    $stmt->execute();
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}


function eliminaPas($con) {

    $id_pas = isset($_POST["id_pas"]) && !empty($_POST["id_pas"]) ? $_POST["id_pas"] : "";
    $id_recepta = isset($_POST["id_recepta"]) && !empty($_POST["id_recepta"]) ? $_POST["id_recepta"] : "";

    $result = mysqli_query($con, "SELECT numero FROM `" . DB_NAME . "`.`Passos` WHERE id = $id_pas");
    $fetch = mysqli_fetch_row($result);
    $numero = $fetch[0];

    $stmt = $con->prepare("UPDATE `" . DB_NAME . "`.`Passos` SET numero = numero-1 WHERE id_recepta = ? AND numero > ?");
    $stmt->bind_param("ii", $id_recepta, $numero);
    $stmt->execute();
    $stmt->close();

    $stmt = $con->prepare("DELETE FROM Passos WHERE id = ?");
    $stmt->bind_param("i", $id_pas);
    $stmt->execute();
    $stmt->close();

    for ($i=1;$i<=3;$i++)
    {
        $nom_foto = $id_pas."_".$i;
        if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".png");
        if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . ".jpg");
        if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.png");
        if(file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/Passos/" . $nom_foto . "_thumb.jpg");
    }

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function eliminaIngredientDeRecepta($con) {

    $id_ingredientarecepta = isset($_POST["id_ingredientarecepta"]) && !empty($_POST["id_ingredientarecepta"]) ? $_POST["id_ingredientarecepta"] : "";

    $stmt = $con->prepare("DELETE FROM IngredientARecepta WHERE id = ?");
    $stmt->bind_param("i", $id_ingredientarecepta);
    $stmt->execute();
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function eliminaEstri($con) {

    $id_estri = isset($_POST["id_estri"]) && !empty($_POST["id_estri"]) ? $_POST["id_estri"] : "";

    $stmt = $con->prepare("DELETE FROM Estris WHERE id = ?");
    $stmt->bind_param("i", $id_estri);
    $stmt->execute();
    $stmt->close();

    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function carregarFotoPas($con) {

    $id_pas = isset($_POST["id_pas"]) && !empty($_POST["id_pas"]) ? str_replace(array("\r", "\n"), '', $_POST["id_pas"]) : "";
    $num_foto = isset($_POST["num_foto"]) && !empty($_POST["num_foto"]) ? str_replace(array("\r", "\n"), '', $_POST["num_foto"]) : "";

    carregarFotoComune("Passos", $id_pas."_".$num_foto);

}

function carregarFotoIngredient($con) {

    $id_ingredient = isset($_POST["id_ingredient"]) && !empty($_POST["id_ingredient"]) ? str_replace(array("\r", "\n"), '', $_POST["id_ingredient"]) : "";

    carregarFotoComune("Ingredients", $id_ingredient);

}

function carregarFotoRecepta($con) {

    $id_recepta = isset($_POST["id_recepta"]) && !empty($_POST["id_recepta"]) ? str_replace(array("\r", "\n"), '', $_POST["id_recepta"]) : "";

    carregarFotoComune("Receptes", $id_recepta);

}

function carregarFotoComune($carpeta, $id_entitat)
{

    if (!isset($_FILES["attachments"])) {

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Hi ha hagut un error pujant la fotografia";
        print json_encode($aReturn);
        return;

    }

    $f = $_FILES["attachments"];

    $g = array();
    $g["name"] = array(
        $f["name"]
    );
    $g["type"] = array(
        $f["type"]
    );
    $g["tmp_name"] = array(
        $f["tmp_name"]
    );
    $g["error"] = array(
        $f["error"]
    );
    $g["size"] = array(
        $f["size"]
    );
    $f = $g;

    if ((! isset($f["name"])) || (count($f["name"]) != 1)) {

        $aReturn = array();
        $aReturn['result'] = "1";
        $aReturn['error'] = "Hi ha hagut un error pujant la fotografia";
        print json_encode($aReturn);
        return;
    }

    foreach ($f["name"] as $k => $name) {

        if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/$carpeta/$id_entitat.jpg"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/$carpeta/$id_entitat.jpg");
        if (file_exists($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/$carpeta/$id_entitat.png"))@unlink($_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/$carpeta/$id_entitat.png");

        $ruta_desti = $_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/$carpeta/$id_entitat.jpg";

        if (($f["error"][$k] == 0) && (move_uploaded_file($f["tmp_name"][$k], $ruta_desti))) {

            @chmod($ruta_desti, 0644);

            resizeImageJPG($ruta_desti, $ruta_desti, 800, 800, 100);

            resizeImageJPG($ruta_desti,  $_SERVER{'DOCUMENT_ROOT'} . "/Imatges_elements/$carpeta/$id_entitat"."_thumb.jpg", 400, 400, 80);

            $aReturn = array();
            $aReturn['result'] = "0";
            print json_encode($aReturn);
            return;

        } else {

            $aReturn = array();
            $aReturn['result'] = "1";
            $aReturn['error'] = "Hi ha hagut un error pujant la fotografia";
            print json_encode($aReturn);
            return;

        }

    }

}

function resizeImageJPG($sourceImage, $targetImage, $maxWidth, $maxHeight, $quality = 80)
{

    // Obtain image from given source file.
    if (!$image = @imagecreatefromjpeg($sourceImage))return false;

    // Get dimensions of source image.
    list($origWidth, $origHeight) = getimagesize($sourceImage);

    if ($maxWidth == 0)$maxWidth  = $origWidth;

    if ($maxHeight == 0)$maxHeight = $origHeight;

    // Calculate ratio of desired maximum sizes and original sizes.
    $widthRatio = $maxWidth / $origWidth;
    $heightRatio = $maxHeight / $origHeight;

    // Ratio used for calculating new image dimensions.
    $ratio = min($widthRatio, $heightRatio);

    // Calculate new image dimensions.
    $newWidth  = (int)$origWidth  * $ratio;
    $newHeight = (int)$origHeight * $ratio;

    // Create final image with new dimensions.
    $newImage = imagecreatetruecolor($newWidth, $newHeight);
    imagecopyresampled($newImage, $image, 0, 0, 0, 0, $newWidth, $newHeight, $origWidth, $origHeight);
    imagejpeg($newImage, $targetImage, $quality);

    // La redrecem si està rotada
    $exif = exif_read_data($sourceImage);
    if(!empty($exif['Orientation'])) {
        $grausRotacio = 0;
        switch($exif['Orientation']) {
            case 8:
                $grausRotacio = 90;
                break;
            case 3:
                $grausRotacio = 180;
                break;
            case 6:
                $grausRotacio = -90;
                break;
        }
        if($grausRotacio != 0){
            $sourceImg = imagecreatefromjpeg($targetImage);
            $newImage = imagerotate($sourceImg,$grausRotacio,0);
            @unlink($targetImage);
            imagejpeg($newImage, $targetImage, 80);
        }
    }

    // Free up the memory.
    imagedestroy($image);
    imagedestroy($newImage);

    return true;

}

/*
function getLastBackup($con) {

    $result = mysqli_query($con, "SELECT id FROM `" . DB_NAME . "`.`Backups` ORDER BY data DESC LIMIT 1");

    $fetch = mysqli_fetch_row($result);

    $_GET["id_backup"] = $fetch[0];

    getBackup($con);

}

function getBackup($con) {

    $con2 = new UTF8_DB(DB_SERVER, DB_USER, DB_PW, DB_NAME);

    $id_backup = $_GET["id_backup"];

    $aEntities = array();

    $result = mysqli_query($con, "SELECT * FROM `" . DB_NAME . "`.`Cansons` WHERE id_backup = '$id_backup' ORDER BY artista ASC");
    while ($row = mysqli_fetch_array($result)) {

        $oEntity = array();

        $oEntity["id"] = $row["id"];
        $oEntity["artista"] = $row["artista"];
        $oEntity["titol"] = $row["titol"];

        // Marques

        $aMarques = array();

        $result2 = mysqli_query($con2, "SELECT * FROM `" . DB_NAME . "`.`Marques` WHERE id_canso = ".$row["id"]);
        while ($row2 = mysqli_fetch_array($result2)) {

            $oMarca = array();
            $oMarca["start"] = $row2["start"];
            $oMarca["num"] = $row2["num"];
            $oMarca["red"] = $row2["red"];
            $oMarca["green"] = $row2["green"];
            $oMarca["blue"] = $row2["blue"];
            array_push($aMarques, $oMarca);

        }

        $oEntity["marques"] = $aMarques;

        // End marques

        array_push($aEntities, $oEntity);

    }

    mysqli_close($con2);

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $aEntities;
    print json_encode($aReturn);

}

function getBackups($con) {

    $aEntities = array();

    $result = mysqli_query($con, "SELECT id, data FROM `" . DB_NAME . "`.`Backups` ORDER BY data DESC");
    while ($row = mysqli_fetch_array($result)) {

        $oEntity = array();

        $oEntity["id"] = $row["id"];
        $oEntity["data"] = $row["data"];

        array_push($aEntities, $oEntity);

    }

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $aEntities;
    print json_encode($aReturn);

}

function eliminaBackup($con) {


    $id_backup = $_GET["id_backup"];

    mysqli_query($con, "DELETE m, c, b FROM `" . DB_NAME . "`.`Marques` m, 
                                         `" . DB_NAME . "`.`Cansons` c,
                                         `" . DB_NAME . "`.`Backups` b 
                                         WHERE 
                                         m.id_canso = c.id AND 
                                         c.id_backup = b.id AND
                                         b.id = $id_backup");


    $aReturn = array();
    $aReturn['result'] = "0";
    print json_encode($aReturn);

}

function crearBackup($con) {


    mysqli_query($con, "DELETE b FROM `" . DB_NAME . "`.`Backups` b");
    mysqli_query($con, "DELETE c FROM `" . DB_NAME . "`.`Cansons` c");
    mysqli_query($con, "DELETE m FROM `" . DB_NAME . "`.`Marques` m");

    mysqli_query($con, "ALTER TABLE `" . DB_NAME . "`.`Backups` AUTO_INCREMENT = 1");
    mysqli_query($con, "ALTER TABLE `" . DB_NAME . "`.`Cansons` AUTO_INCREMENT = 1");
    mysqli_query($con, "ALTER TABLE `" . DB_NAME . "`.`Marques` AUTO_INCREMENT = 1");

    mysqli_query($con, "INSERT INTO  `" . DB_NAME . "`.`Backups` 
                            (`data`) VALUES 
                            (NOW())");

    $id_backup_afegit = mysqli_insert_id($con);

    $aReturn = array();
    $aReturn['result'] = "0";
    $aReturn['data'] = $id_backup_afegit;
    print json_encode($aReturn);

}

function afegirCansoABackup($con) {


    if((isset($_POST["id_backup"])) && (!empty($_POST["id_backup"]))){

        $id_backup = $_POST["id_backup"];

        if((isset($_POST["oMarkedSong"])) && (!empty($_POST["oMarkedSong"]))){

            $oCanso = $_POST["oMarkedSong"];

            if(isset($oCanso["artist"]) && isset($oCanso["title"])) {

                $stmt = $con->prepare("INSERT INTO `" . DB_NAME . "`.`Cansons` (id_backup, artista, titol) VALUES (?, ?, ?)");
                $stmt->bind_param("iss", $id_backup, $oCanso["artist"], $oCanso["title"]);
                $stmt->execute();
                $id_canso_afegida = $stmt->insert_id;
                $stmt->close();

                foreach ($oCanso["aMarks"] as $oMarca) {

                    $start = $oMarca["start"];
                    $num = $oMarca["num"];
                    $red = $oMarca["red"];
                    $green = $oMarca["green"];
                    $blue = $oMarca["blue"];

                    $stmt = $con->prepare("INSERT INTO `" . DB_NAME . "`.`Marques` (id_canso, start, num, red, green, blue) VALUES (?, ?, ?, ?, ?, ?)");
                    $stmt->bind_param("iiiiii", $id_canso_afegida, $start, $num, $red, $green, $blue);
                    $stmt->execute();
                    $stmt->close();

                }

            }

            $aReturn = array();
            $aReturn['result'] = "0";
            print json_encode($aReturn);

        }else{

            $aReturn = array();
            $aReturn['result'] = "1";
            $aReturn['error'] = "Paràmetre cançó no existent";
            print json_encode($aReturn);

        }

    }

}
*/

function loguejarErrorArray($a) {

    ob_start();
    print_r($a);
    $cont = ob_get_contents();
    error_log("loguejarErrorArray = $cont");
    ob_end_clean();

}

?>