-- phpMyAdmin SQL Dump
-- version 4.4.10
-- http://www.phpmyadmin.net
--
-- Servidor: localhost:8889
-- Tiempo de generación: 07-06-2020 a las 01:36:11
-- Versión del servidor: 5.5.42
-- Versión de PHP: 5.6.10

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Base de datos: `ataula`
--
CREATE DATABASE IF NOT EXISTS `ataula` DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
USE `ataula`;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `Estris`
--

CREATE TABLE `Estris` (
  `id` int(11) NOT NULL,
  `nom` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL,
  `genere` varchar(1) COLLATE utf8mb4_unicode_ci NOT NULL
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

--
-- Volcado de datos para la tabla `Estris`
--

INSERT INTO `Estris` (`id`, `nom`, `genere`) VALUES
(1, 'Paella gran (28 cm ⌀)', 'F'),
(2, 'Paella mitjana (25 cm ⌀)', 'F'),
(3, 'Paella petita (20 cm ⌀)', 'F'),
(4, 'Colador', 'M'),
(5, 'Escumadera', 'F'),
(6, 'Escorredora', 'F'),
(7, 'Olla petita (2 L.)', 'F'),
(8, 'Olla gran (5 L.)', 'F'),
(9, 'Cassó', 'M'),
(10, 'Forn', 'M'),
(13, 'Planxa', 'F');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `IngredientARecepta`
--

CREATE TABLE `IngredientARecepta` (
  `id` int(11) NOT NULL,
  `id_ingredient` int(11) NOT NULL,
  `id_recepta` int(11) NOT NULL,
  `quantitat` double NOT NULL,
  `utilitza_unitat` tinyint(1) NOT NULL
) ENGINE=MyISAM AUTO_INCREMENT=97 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

--
-- Volcado de datos para la tabla `IngredientARecepta`
--

INSERT INTO `IngredientARecepta` (`id`, `id_ingredient`, `id_recepta`, `quantitat`, `utilitza_unitat`) VALUES
(95, 39, 16, 0, 0),
(94, 38, 16, 6, 0),
(93, 16, 16, 700, 1),
(91, 10, 16, 0, 0),
(90, 6, 16, 4, 0),
(88, 30, 16, 1, 0),
(87, 15, 16, 2, 0),
(86, 7, 16, 0, 0),
(85, 31, 16, 0, 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `Ingredients`
--

CREATE TABLE `Ingredients` (
  `id` int(11) NOT NULL,
  `nom_singular` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL,
  `nom_plural` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL,
  `genere` varchar(1) COLLATE utf8mb4_unicode_ci NOT NULL,
  `unitat` varchar(2) COLLATE utf8mb4_unicode_ci NOT NULL
) ENGINE=MyISAM AUTO_INCREMENT=41 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

--
-- Volcado de datos para la tabla `Ingredients`
--

INSERT INTO `Ingredients` (`id`, `nom_singular`, `nom_plural`, `genere`, `unitat`) VALUES
(1, '', 'Ametlles torrades', 'F', 'g'),
(2, '', 'Olives negres d''Aragó', 'F', 'g'),
(3, '', 'Llenties', 'F', 'g'),
(4, 'Mantega', '', 'F', 'g'),
(5, 'Arròs rodó Bayo', '', 'M', 'g'),
(6, 'All', 'Alls', 'M', 'g'),
(7, 'Pollastre', 'Pollastres', 'M', 'g'),
(9, 'Poma', 'Pomes', 'F', 'g'),
(10, 'Julivert', '', 'M', 'g'),
(11, 'Ou', 'Ous', 'M', 'g'),
(12, 'Pot de tomàquet triturat', 'Pots de tomàquet triturat', 'M', 'g'),
(13, 'Oli', '', 'M', 'ml'),
(14, 'Sal fina', '', 'F', 'g'),
(15, 'Pebrot verd italià', 'Pebrots verds italians', 'M', 'g'),
(16, 'Brou de verdura', '', 'M', 'ml'),
(17, 'Pera', 'Peres', 'F', 'g'),
(31, 'Arròs integral Nomen ', '', 'M', 'g'),
(19, 'Carbassó', 'Carbassons', 'M', 'g'),
(30, 'Pebrot vermell llarg', 'Pebrots vermells llargs', 'M', 'g'),
(38, 'Pastanaga', 'Pastanagues', 'F', 'g'),
(39, 'Jalapeño', 'Jalapeños', 'M', 'g');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `Passos`
--

CREATE TABLE `Passos` (
  `id` int(11) NOT NULL,
  `id_recepta` int(11) NOT NULL,
  `numero` int(11) NOT NULL,
  `descripcio` text COLLATE utf8mb4_unicode_ci NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

--
-- Volcado de datos para la tabla `Passos`
--

INSERT INTO `Passos` (`id`, `id_recepta`, `numero`, `descripcio`) VALUES
(1, 16, 1, 'Fregir el pollastre a daus a la paella mitjana a foc fort durant 10 minuts.'),
(2, 16, 2, 'Sf'),
(3, 16, 3, 'Af'),
(4, 16, 4, 'Pas sense fotos');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `Receptes`
--

CREATE TABLE `Receptes` (
  `id` int(11) NOT NULL,
  `titol` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT '',
  `preu` int(11) DEFAULT NULL,
  `temps` int(11) DEFAULT NULL,
  `data_creacio` datetime NOT NULL
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

--
-- Volcado de datos para la tabla `Receptes`
--

INSERT INTO `Receptes` (`id`, `titol`, `preu`, `temps`, `data_creacio`) VALUES
(20, '', NULL, NULL, '2020-04-24 01:14:08'),
(16, 'Arròs amb pollastre', 90, NULL, '2020-04-20 00:05:30'),
(18, 'Col amb pastanaga', NULL, NULL, '2020-04-24 01:10:35'),
(19, 'Macarrons', NULL, NULL, '2020-04-24 01:10:48');

--
-- Índices para tablas volcadas
--

--
-- Indices de la tabla `Estris`
--
ALTER TABLE `Estris`
  ADD PRIMARY KEY (`id`);

--
-- Indices de la tabla `IngredientARecepta`
--
ALTER TABLE `IngredientARecepta`
  ADD PRIMARY KEY (`id`);

--
-- Indices de la tabla `Ingredients`
--
ALTER TABLE `Ingredients`
  ADD PRIMARY KEY (`id`);

--
-- Indices de la tabla `Passos`
--
ALTER TABLE `Passos`
  ADD PRIMARY KEY (`id`);

--
-- Indices de la tabla `Receptes`
--
ALTER TABLE `Receptes`
  ADD PRIMARY KEY (`id`);

--
-- AUTO_INCREMENT de las tablas volcadas
--

--
-- AUTO_INCREMENT de la tabla `Estris`
--
ALTER TABLE `Estris`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=14;
--
-- AUTO_INCREMENT de la tabla `IngredientARecepta`
--
ALTER TABLE `IngredientARecepta`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=97;
--
-- AUTO_INCREMENT de la tabla `Ingredients`
--
ALTER TABLE `Ingredients`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=41;
--
-- AUTO_INCREMENT de la tabla `Passos`
--
ALTER TABLE `Passos`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=5;
--
-- AUTO_INCREMENT de la tabla `Receptes`
--
ALTER TABLE `Receptes`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=21;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
