//
//  ViewControllerPas.h
//  ataula
//
//  Created by Andreu Biosca on 08/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuickLook/QuickLook.h>

@class ViewControllerRecepta;
@class TextViewPas;

NS_ASSUME_NONNULL_BEGIN

@interface ViewControllerPas : UIViewController <UINavigationControllerDelegate, UIImagePickerControllerDelegate, QLPreviewControllerDataSource, QLPreviewControllerDelegate, UICollectionViewDelegate, UICollectionViewDataSource, UIScrollViewDelegate>

@property ViewControllerRecepta *oViewControllerRecepta;

@property UIView *vista_preloader;
@property (strong, nonatomic) IBOutlet UIButton *boto_accio;
@property NSString *idPas;

@property (strong, nonatomic) IBOutlet UIScrollView *scrollview;

@property (strong, nonatomic) IBOutlet UIImageView *camera1;
@property (strong, nonatomic) IBOutlet UIImageView *camera2;
@property (strong, nonatomic) IBOutlet UIImageView *camera3;

@property NSData *dataNovaImatge1;
@property NSData *dataNovaImatge2;
@property NSData *dataNovaImatge3;

@property (strong, nonatomic) IBOutlet UIView *vistaFoto1;
@property (strong, nonatomic) IBOutlet UIView *vistaFoto2;
@property (strong, nonatomic) IBOutlet UIView *vistaFoto3;

@property UIImageView *imgvFoto1;
@property UIImageView *imgvFoto2;
@property UIImageView *imgvFoto3;
@property int iBucleFotosActual;
@property NSMutableArray *aTempDocumentURL;

@property NSString *sTagFotoSeleccionada;

@property NSMutableArray *aFotosEliminar;

@property (strong, nonatomic) IBOutlet UIView *vista_capçalera_predictiu;
@property (strong, nonatomic) IBOutlet UICollectionView *collectionview;
@property (strong, nonatomic) IBOutlet UIView *vistaFonsCollectionView;
@property (strong, nonatomic) IBOutlet TextViewPas *textview_predicció;
@property (strong, nonatomic) IBOutlet UILabel *label_capçalera_predictiu;
@property (strong, nonatomic) IBOutlet UIButton *botoSeguentBlocPredictiu;

@property NSMutableArray *aPrediccio;
@property NSMutableArray *aParaulesCollectionView;
@property int iBlocPrediccioActual;
@property bool bHemAfegitIngredient;
@property NSRange rangDarreraIIngredient;
@property NSMutableArray *aInstancies_estris;
@property NSMutableArray *aParaulesRealsCollectionView;
@property bool bJaEmFetConjuncioFinal;
@property int id_estri_escollit;

-(void)reiniciaPredictiuEnFuncioTextView;

@end

NS_ASSUME_NONNULL_END
