//
//  ViewControllerRecepta.h
//  ataula
//
//  Created by Andreu Biosca on 07/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuickLook/QuickLook.h>

@class ViewControllerReceptes;

#define X_TEXTVIEW_PAS_DESCRIPCIO 60
#define Y_TEXTVIEW_PAS_DESCRIPCIO 5
#define ML_TEXTVIEW_PAS_DESCRIPCIO 20

NS_ASSUME_NONNULL_BEGIN

@interface ViewControllerRecepta : UIViewController <UITableViewDelegate, UITableViewDataSource, UITextFieldDelegate, UIImagePickerControllerDelegate, QLPreviewControllerDelegate, QLPreviewControllerDataSource, UINavigationControllerDelegate>

@property NSString *idRecepta;
@property UIView *vista_preloader;
@property ViewControllerReceptes *oViewControllerReceptes;

@property (strong, nonatomic) IBOutlet UITableView *tableview_ingredients;
@property (strong, nonatomic) IBOutlet UITableView *tableview_passos;

@property (strong, nonatomic) IBOutlet UITextField *textfield_titol;
@property (strong, nonatomic) IBOutlet UITextField *textfield_temps;
@property (strong, nonatomic) IBOutlet UITextField *textfield_preu;

@property (strong, nonatomic) IBOutlet UIView *vistaFoto;
@property UIImageView *imgvFoto;
@property (strong, nonatomic) IBOutlet UIImageView *camera;
@property (strong, nonatomic) IBOutlet UIButton *botoAfegirIngredient;
@property (strong, nonatomic) IBOutlet UIButton *botoAfegirPas;

@property NSMutableArray *aTempDocumentURL;

@property (strong, nonatomic) IBOutlet UIView *liniaUltrafinaSeparadoraBlocs;
@property (strong, nonatomic) IBOutlet UIButton *boto_ulleres_ingredients;
@property (strong, nonatomic) IBOutlet UIButton *boto_ulleres_passos;

@property NSMutableArray *aInstancies_ingredients;
@property NSMutableArray *aInstancies_passos;
@property bool bIgnoraRestriccioDigits;
@property (strong, nonatomic) IBOutlet UIView *vista_bloc_ingredients;
@property (strong, nonatomic) IBOutlet UIView *vista_bloc_passos;
@property (strong, nonatomic) IBOutlet UIView *vista_2_blocs;

-(void)refrescaIngredientsRecepta;
-(void)refrescaPassosRecepta;

@end

NS_ASSUME_NONNULL_END
